{
    "$graph": [
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "id": "#main/avg.freqstep"
                },
                {
                    "type": "int",
                    "id": "#main/avg.timestep"
                },
                {
                    "type": "float",
                    "id": "#main/cellsize_lowres_deg"
                },
                {
                    "type": "string",
                    "id": "#main/flag.baseline"
                },
                {
                    "type": "float",
                    "id": "#main/image_padding"
                },
                {
                    "type": "int",
                    "id": "#main/maxlambda_lowres"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#main/ms_array"
                },
                {
                    "type": "string",
                    "id": "#main/reference_station"
                }
            ],
            "steps": [
                {
                    "run": "#ampl.cwl",
                    "in": [
                        {
                            "source": "#main/h5imp_cal/losoto_h5",
                            "id": "#main/ampl/globaldbname"
                        }
                    ],
                    "out": [
                        "#main/ampl/amplitude_array"
                    ],
                    "id": "#main/ampl"
                },
                {
                    "run": "#calib_cal.cwl",
                    "in": [
                        {
                            "source": "#main/sky_cal/skymodel",
                            "id": "#main/calib_cal/catalog"
                        },
                        {
                            "source": "#main/ndppp_prep_cal/msout",
                            "id": "#main/calib_cal/observation"
                        }
                    ],
                    "scatter": [
                        "#main/calib_cal/observation",
                        "#main/calib_cal/catalog"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#main/calib_cal/mscalib"
                    ],
                    "id": "#main/calib_cal"
                },
                {
                    "run": "#create_image.cwl",
                    "in": [
                        {
                            "source": "#main/cellsize_lowres_deg",
                            "id": "#main/create_image/cellsize_lowres_deg"
                        },
                        {
                            "source": "#main/image_padding",
                            "id": "#main/create_image/image_padding"
                        },
                        {
                            "source": "#main/do_magic/mapfile_deep_low_size",
                            "id": "#main/create_image/mapfile_deep_low_size"
                        },
                        {
                            "source": "#main/do_magic/mapfile_nchansout_clean1",
                            "id": "#main/create_image/mapfile_nchansout_clean1"
                        },
                        {
                            "source": "#main/do_magic/mapfile_nwavelengths_low",
                            "id": "#main/create_image/mapfile_nwavelengths_low"
                        },
                        {
                            "source": "#main/maxlambda_lowres",
                            "id": "#main/create_image/maxlambda_lowres"
                        },
                        {
                            "source": "#main/calib_cal/mscalib",
                            "id": "#main/create_image/prepcals"
                        }
                    ],
                    "out": [
                        "#main/create_image/psf",
                        "#main/create_image/dirty",
                        "#main/create_image/residual",
                        "#main/create_image/model"
                    ],
                    "id": "#main/create_image"
                },
                {
                    "run": "#do_magic.cwl",
                    "in": [
                        {
                            "source": "#main/calib_cal/mscalib",
                            "id": "#main/do_magic/prepcals"
                        }
                    ],
                    "out": [
                        "#main/do_magic/mapfile_paths",
                        "#main/do_magic/mapfile_deep_high_padded",
                        "#main/do_magic/mapfile_deep_high_size",
                        "#main/do_magic/mapfile_deep_low_padded_size",
                        "#main/do_magic/mapfile_deep_low_size",
                        "#main/do_magic/mapfile_freqstep",
                        "#main/do_magic/mapfile_high_padded_size",
                        "#main/do_magic/mapfile_high_size",
                        "#main/do_magic/mapfile_low_padded_size",
                        "#main/do_magic/mapfile_low_size",
                        "#main/do_magic/mapfile_nbands",
                        "#main/do_magic/mapfile_nchansout_clean1",
                        "#main/do_magic/mapfile_nwavelengths_high",
                        "#main/do_magic/mapfile_nwavelengths_low",
                        "#main/do_magic/mapfile_single",
                        "#main/do_magic/mapfile_timestep"
                    ],
                    "id": "#main/do_magic"
                },
                {
                    "run": "#fitclock.cwl",
                    "in": [
                        {
                            "source": "#main/h5imp_cal/losoto_h5",
                            "id": "#main/fitclock/globaldbname"
                        }
                    ],
                    "out": [
                        "#main/fitclock/dTEC_1st",
                        "#main/fitclock/dTEC_1st_sm",
                        "#main/fitclock/dclock_1st",
                        "#main/fitclock/dclock_1st_sm"
                    ],
                    "id": "#main/fitclock"
                },
                {
                    "run": "#h5imp_cal.cwl",
                    "in": [
                        {
                            "source": "#main/calib_cal/mscalib",
                            "id": "#main/h5imp_cal/ms_array"
                        }
                    ],
                    "out": [
                        "#main/h5imp_cal/losoto_h5"
                    ],
                    "id": "#main/h5imp_cal"
                },
                {
                    "run": "#ndppp_prep_cal.cwl",
                    "in": [
                        {
                            "source": "#main/avg.freqstep",
                            "id": "#main/ndppp_prep_cal/avg.freqstep"
                        },
                        {
                            "source": "#main/avg.timestep",
                            "id": "#main/ndppp_prep_cal/avg.timestep"
                        },
                        {
                            "source": "#main/flag.baseline",
                            "id": "#main/ndppp_prep_cal/flag.baseline"
                        },
                        {
                            "source": "#main/ms_array",
                            "id": "#main/ndppp_prep_cal/msin"
                        }
                    ],
                    "scatter": "#main/ndppp_prep_cal/msin",
                    "out": [
                        "#main/ndppp_prep_cal/msout"
                    ],
                    "id": "#main/ndppp_prep_cal"
                },
                {
                    "run": "#phase.cwl",
                    "in": [
                        {
                            "source": "#main/h5imp_cal/losoto_h5",
                            "id": "#main/phase/losoto"
                        }
                    ],
                    "out": [
                        "#main/phase/freqs_for_phase_array",
                        "#main/phase/phase_array",
                        "#main/phase/station_names",
                        "#main/phase/phase_xx_yy_offset"
                    ],
                    "id": "#main/phase"
                },
                {
                    "run": "#plot_cal_phases.cwl",
                    "in": [
                        {
                            "source": "#main/h5imp_cal/losoto_h5",
                            "id": "#main/plot_cal_phases/h5parm"
                        },
                        {
                            "source": "#main/reference_station",
                            "id": "#main/plot_cal_phases/reference_station"
                        }
                    ],
                    "out": [
                        "#main/plot_cal_phases/polXX_dirpointing",
                        "#main/plot_cal_phases/polYY_dirpointing"
                    ],
                    "id": "#main/plot_cal_phases"
                },
                {
                    "run": "#plots.cwl",
                    "in": [
                        {
                            "source": "#main/ampl/amplitude_array",
                            "id": "#main/plots/amplitude_array"
                        },
                        {
                            "source": "#main/fitclock/dclock_1st",
                            "id": "#main/plots/dclock_1st"
                        },
                        {
                            "source": "#main/fitclock/dclock_1st_sm",
                            "id": "#main/plots/dclock_1st_sm"
                        },
                        {
                            "source": "#main/fitclock/dTEC_1st_sm",
                            "id": "#main/plots/dtec_1st_sm"
                        }
                    ],
                    "out": [
                        "#main/plots/dtec_allsols",
                        "#main/plots/dclock_allsols",
                        "#main/plots/amp_allsols"
                    ],
                    "id": "#main/plots"
                },
                {
                    "run": "#sky_cal.cwl",
                    "in": [
                        {
                            "source": "#main/ndppp_prep_cal/msout",
                            "id": "#main/sky_cal/ms"
                        }
                    ],
                    "scatter": "#main/sky_cal/ms",
                    "out": [
                        "#main/sky_cal/skymodel"
                    ],
                    "id": "#main/sky_cal"
                }
            ],
            "id": "#main",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": [
                {
                    "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
                },
                {
                    "http://schema.org/person.url": "https://orcid.org/0000-0001-5125-9539"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/png",
                    "outputSource": "#main/plots/amp_allsols",
                    "id": "#main/amp_allsols"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Amplitude solutions",
                    "outputSource": "#main/ampl/amplitude_array",
                    "id": "#main/amplitude_array"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "TEC solutions",
                    "outputSource": "#main/fitclock/dTEC_1st",
                    "id": "#main/dTEC_1st"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Smoothed TEC solutions",
                    "outputSource": "#main/fitclock/dTEC_1st_sm",
                    "id": "#main/dTEC_1st_sm"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Clock solutions",
                    "outputSource": "#main/fitclock/dclock_1st",
                    "id": "#main/dclock_1st"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Smoothed clock solutions",
                    "outputSource": "#main/fitclock/dclock_1st_sm",
                    "id": "#main/dclock_1st_sm"
                },
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/png",
                    "outputSource": "#main/plots/dclock_allsols",
                    "id": "#main/dclock_allsols"
                },
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/fits",
                    "outputSource": "#main/create_image/dirty",
                    "id": "#main/dirty"
                },
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/png",
                    "outputSource": "#main/plots/dtec_allsols",
                    "id": "#main/dtec_allsols"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Frequencies",
                    "outputSource": "#main/phase/freqs_for_phase_array",
                    "id": "#main/freqs_for_phase_array"
                },
                {
                    "type": "File",
                    "format": "http://revoltek.github.io/losoto/cookbook.pdf",
                    "label": "H5Parm solutions",
                    "outputSource": "#main/h5imp_cal/losoto_h5",
                    "id": "#main/losoto_h5"
                },
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/fits",
                    "outputSource": "#main/create_image/model",
                    "id": "#main/model"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Phase solutions",
                    "outputSource": "#main/phase/phase_array",
                    "id": "#main/phase_array"
                },
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/png",
                    "outputSource": "#main/phase/phase_xx_yy_offset",
                    "id": "#main/phase_xx_yy_offset"
                },
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/png",
                    "outputSource": "#main/plot_cal_phases/polXX_dirpointing",
                    "id": "#main/polXX_dirpointing"
                },
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/png",
                    "outputSource": "#main/plot_cal_phases/polYY_dirpointing",
                    "id": "#main/polYY_dirpointing"
                },
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/fits",
                    "outputSource": "#main/create_image/psf",
                    "id": "#main/psf"
                },
                {
                    "type": "File",
                    "format": "https://www.iana.org/assignments/media-types/image/fits",
                    "outputSource": "#main/create_image/residual",
                    "id": "#main/residual"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Station names",
                    "outputSource": "#main/phase/station_names",
                    "id": "#main/station_names"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "/usr/lib/prefactor/scripts/amplitudes_losoto_3.py"
            ],
            "label": "Smooth amplitudes",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "int"
                        }
                    ],
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#ampl.cwl/bad_sblist"
                },
                {
                    "type": "File",
                    "format": "http://revoltek.github.io/losoto/cookbook.pdf",
                    "label": "Input H5Parm",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#ampl.cwl/globaldbname"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "number of channels solved for per subband (i.e., number of solutions along frequencies axis of MS)",
                    "default": 4,
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#ampl.cwl/n_chan"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "fitclock",
                    "position": 2
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Smoothed amplitudes",
                    "outputBinding": {
                        "glob": "fitclock_amplitude_array.npy"
                    },
                    "id": "#ampl.cwl/amplitude_array"
                }
            ],
            "id": "#ampl.cwl",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": {
                "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
            }
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/usr/bin/calibrate-stand-alone"
            ],
            "label": "BBS calibrate",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "requirements": [
                {
                    "class": "EnvVarRequirement",
                    "envDef": [
                        {
                            "envValue": "/usr",
                            "envName": "LOFARROOT"
                        }
                    ]
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.observation)",
                            "writable": true
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#calib_cal.cwl/catalog"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#calib_cal.cwl/observation"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(runtime.cores)",
                    "prefix": "--numthreads"
                },
                {
                    "valueFrom": "/usr/share/prefactor/parsets/calibcal.parset",
                    "position": 2
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.observation.basename)"
                    },
                    "id": "#calib_cal.cwl/mscalib"
                }
            ],
            "id": "#calib_cal.cwl",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": {
                "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
            }
        },
        {
            "class": "CommandLineTool",
            "id": "#create_image.cwl",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": [
                "python"
            ],
            "inputs": [
                {
                    "id": "#create_image.cwl/create_image/mapfile_deep_low_size",
                    "type": "File"
                },
                {
                    "id": "#create_image.cwl/create_image/mapfile_nchansout_clean1",
                    "type": "File"
                },
                {
                    "id": "#create_image.cwl/create_image/mapfile_nwavelengths_low",
                    "type": "File"
                },
                {
                    "id": "#create_image.cwl/create_image/image_padding",
                    "type": "float"
                },
                {
                    "id": "#create_image.cwl/create_image/maxlambda_lowres",
                    "type": "int"
                },
                {
                    "id": "#create_image.cwl/create_image/cellsize_lowres_deg",
                    "type": "float"
                },
                {
                    "id": "#create_image.cwl/create_image/prepcals",
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "position": 19
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#create_image.cwl/create_image/psf",
                    "type": "File",
                    "outputBinding": {
                        "glob": "wsclean-MFS-psf.fits"
                    }
                },
                {
                    "id": "#create_image.cwl/create_image/dirty",
                    "type": "File",
                    "outputBinding": {
                        "glob": "wsclean-MFS-dirty.fits"
                    }
                },
                {
                    "id": "#create_image.cwl/create_image/residual",
                    "type": "File",
                    "outputBinding": {
                        "glob": "wsclean-MFS-residual.fits"
                    }
                },
                {
                    "id": "#create_image.cwl/create_image/model",
                    "type": "File",
                    "outputBinding": {
                        "glob": "wsclean-MFS-model.fits"
                    }
                }
            ],
            "label": "create_image",
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "import ast\nimport sys\nimport subprocess as SP\ncmlopts = [\"wsclean\"]\npadfil = open(\"$(inputs.mapfile_deep_low_size.path)\")\ncmlopts.append(\"-size\")\ncmlopts.extend(ast.literal_eval(padfil.read())[0][\"file\"].split())\nncfil = open(\"$(inputs.mapfile_nchansout_clean1.path)\")\ncmlopts.append(\"-channels-out\")\ncmlopts.append(ast.literal_eval(ncfil.read())[0][\"file\"])\nnwfil = open(\"$(inputs.mapfile_nwavelengths_low.path)\")\ncmlopts.append(\"-baseline-averaging\")\ncmlopts.append(ast.literal_eval(nwfil.read())[0][\"file\"])\ncmlopts.extend(sys.argv[1:])\nprint \" \".join(cmlopts)\nSP.call(cmlopts)\n"
                },
                {
                    "prefix": "-padding",
                    "valueFrom": "$(inputs.image_padding)"
                },
                {
                    "prefix": "-niter",
                    "valueFrom": "20000"
                },
                {
                    "prefix": "-threshold",
                    "valueFrom": "0.0"
                },
                {
                    "prefix": "-pol",
                    "valueFrom": "I"
                },
                {
                    "prefix": "-weight",
                    "valueFrom": "briggs"
                },
                {
                    "valueFrom": "0.0"
                },
                {
                    "prefix": "-mgain",
                    "valueFrom": "0.65"
                },
                {
                    "prefix": "-minuv-l",
                    "valueFrom": "80"
                },
                {
                    "prefix": "-maxuv-l",
                    "valueFrom": "$(inputs.maxlambda_lowres)"
                },
                {
                    "prefix": "-weighting-rank-filter",
                    "valueFrom": "3"
                },
                {
                    "prefix": "-temp-dir",
                    "valueFrom": "$(runtime.tmpdir)"
                },
                {
                    "prefix": "-scale",
                    "valueFrom": "$(inputs.cellsize_lowres_deg)"
                },
                {
                    "prefix": "-j",
                    "valueFrom": "$(runtime.cores)"
                },
                {
                    "prefix": "-abs-mem",
                    "valueFrom": "$(runtime.ram)"
                },
                "-no-update-model-required",
                "-reorder",
                "-fit-beam",
                "-join-channels"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "http://schema.org/author": {
                "http://schema.org/person.url": "https://orcid.org/0000-0001-5125-9539"
            },
            "http://schema.org/license": "https://mit-license.org/"
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": [
                "python"
            ],
            "inputs": [
                {
                    "id": "#do_magic.cwl/prepcals",
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "position": 0
                    },
                    "doc": "list of calibrated measurement sets"
                }
            ],
            "outputs": [
                {
                    "id": "#do_magic.cwl/mapfile_paths",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_deep_high_padded",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_deep_high_padded_size"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_deep_high_size",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_deep_high_size"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_deep_low_padded_size",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_deep_low_padded_size"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_deep_low_size",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_deep_low_size"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_freqstep",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_freqstep"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_high_padded_size",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_high_padded_size"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_high_size",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_high_size"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_low_padded_size",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_low_padded_size"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_low_size",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_low_size"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_nbands",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_nbands"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_nchansout_clean1",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_nchansout_clean1"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_nwavelengths_high",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_nwavelengths_high"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_nwavelengths_low",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_nwavelengths_low"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_single",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_single"
                    }
                },
                {
                    "id": "#do_magic.cwl/mapfile_timestep",
                    "type": "File",
                    "outputBinding": {
                        "glob": "cwl_timestep"
                    }
                }
            ],
            "label": "_do_magic",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "-c",
                    "valueFrom": "import InitSubtract_deep_sort_and_compute as Isub_deep\nimport os\nimport sys\ninputfiles = sys.argv[1:]\nprint(inputfiles)\nIsub_deep.main(inputfiles,\n     outmapname=\"cwl\",\n     mapfile_dir=os.path.basename(\".\"))\n"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "id": "#do_magic.cwl",
            "http://schema.org/author": {
                "http://schema.org/person.url": "https://orcid.org/0000-0001-5125-9539"
            },
            "http://schema.org/license": "https://mit-license.org/"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "/usr/lib/prefactor/scripts/fit_clocktec_initialguess_losoto.py"
            ],
            "label": "Separate clock/TEC",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "format": "http://revoltek.github.io/losoto/cookbook.pdf",
                    "doc": "input h5 parm file",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#fitclock.cwl/globaldbname"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "fitclock",
                    "position": 2
                },
                {
                    "valueFrom": "$(runtime.cores)",
                    "position": 3
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "TEC solutions",
                    "outputBinding": {
                        "glob": "fitted_data_dTEC_fitclock_1st.npy"
                    },
                    "id": "#fitclock.cwl/dTEC_1st"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Smoothed TEC solutions",
                    "outputBinding": {
                        "glob": "fitted_data_dTEC_fitclock_1st.sm.npy"
                    },
                    "id": "#fitclock.cwl/dTEC_1st_sm"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Clock solutions",
                    "outputBinding": {
                        "glob": "fitted_data_dclock_fitclock_1st.npy"
                    },
                    "id": "#fitclock.cwl/dclock_1st"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Smoothed clock solutions",
                    "outputBinding": {
                        "glob": "fitted_data_dclock_fitclock_1st.sm.npy"
                    },
                    "id": "#fitclock.cwl/dclock_1st_sm"
                }
            ],
            "id": "#fitclock.cwl",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": {
                "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
            }
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "/usr/lib/prefactor/scripts/losotoImporter.py",
                "losoto.h5"
            ],
            "label": "Convert solutions to H5parm",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "doc": "Compression level from 0 (no compression, fast) to 9",
                    "default": 7,
                    "inputBinding": {
                        "prefix": "-c"
                    },
                    "id": "#h5imp_cal.cwl/complevel"
                },
                {
                    "type": "string",
                    "doc": "Name of instrument tables of measurement sets. If starts with '/' -> instrument table is sub- directory within the MS directory",
                    "default": "/instrument",
                    "id": "#h5imp_cal.cwl/instrument"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "doc": "List of path patterns of measurement sets with instrument tables",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#h5imp_cal.cwl/ms_array"
                },
                {
                    "type": "string",
                    "doc": "Solution-set name",
                    "default": "sol000",
                    "inputBinding": {
                        "prefix": "-s"
                    },
                    "id": "#h5imp_cal.cwl/solset"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-v"
                    },
                    "id": "#h5imp_cal.cwl/verbose"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "format": "http://revoltek.github.io/losoto/cookbook.pdf",
                    "label": "H5Parm solutions",
                    "outputBinding": {
                        "glob": "losoto.h5"
                    },
                    "id": "#h5imp_cal.cwl/losoto_h5"
                }
            ],
            "id": "#h5imp_cal.cwl",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": {
                "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
            }
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "NDPPP",
                "msout=calibrated.MS"
            ],
            "label": "DPPP flag and average",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "48.82kHz",
                    "inputBinding": {
                        "prefix": "average.freqresolution=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/avg.freqresolution"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "avg.freqstep=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/avg.freqstep"
                },
                {
                    "type": "int",
                    "default": 4,
                    "inputBinding": {
                        "prefix": "average.timeresolution=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/avg.timeresolution"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "avg.timestep=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/avg.timestep"
                },
                {
                    "type": "string",
                    "default": "average",
                    "inputBinding": {
                        "prefix": "avg.type=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/avg.type"
                },
                {
                    "type": "string",
                    "default": "[CS013HBA*]",
                    "inputBinding": {
                        "prefix": "baseline=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/baseline"
                },
                {
                    "type": "string",
                    "default": "CS*, RS*&&",
                    "inputBinding": {
                        "prefix": "filter.baseline=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/filter.baseline"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#ndppp_prep_cal.cwl/filter.remove/True",
                            "#ndppp_prep_cal.cwl/filter.remove/False"
                        ]
                    },
                    "default": "True",
                    "inputBinding": {
                        "prefix": "filter.remove=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/filter.remove"
                },
                {
                    "type": "string",
                    "default": "filter",
                    "inputBinding": {
                        "prefix": "filter.type=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/filter.type"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "flag.baseline=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/flag.baseline"
                },
                {
                    "type": "string",
                    "default": "filter",
                    "inputBinding": {
                        "prefix": "flag.type=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/flag.type"
                },
                {
                    "type": "string",
                    "default": "1e-30",
                    "inputBinding": {
                        "prefix": "flagamp.amplmin=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/flagamp.amplmin"
                },
                {
                    "type": "string",
                    "default": "preflagger",
                    "inputBinding": {
                        "prefix": "flagamp.type=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/flagamp.type"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "msin=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/msin"
                },
                {
                    "type": "string",
                    "default": "DATA",
                    "inputBinding": {
                        "prefix": "msin.datacolumn=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/msin.datacolumn"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#ndppp_prep_cal.cwl/msout.overwrite/True",
                            "#ndppp_prep_cal.cwl/msout.overwrite/False"
                        ]
                    },
                    "default": "True",
                    "inputBinding": {
                        "prefix": "msout.overwrite=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/msout.overwrite"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#ndppp_prep_cal.cwl/msout.writefullresflag/True",
                            "#ndppp_prep_cal.cwl/msout.writefullresflag/False"
                        ]
                    },
                    "default": "False",
                    "inputBinding": {
                        "prefix": "msout.writefullresflag=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/msout.writefullresflag"
                },
                {
                    "type": "string",
                    "default": "[flag,filter,avg,flagamp]",
                    "inputBinding": {
                        "prefix": "steps=",
                        "separate": false
                    },
                    "id": "#ndppp_prep_cal.cwl/steps"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "calibrated.MS"
                    },
                    "id": "#ndppp_prep_cal.cwl/msout"
                }
            ],
            "id": "#ndppp_prep_cal.cwl",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": {
                "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
            }
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python"
            ],
            "label": "Find global phase offset",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "format": "http://revoltek.github.io/losoto/cookbook.pdf",
                    "id": "#phase.cwl/losoto"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 2,
                    "id": "#phase.cwl/refstation_id"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 0,
                    "id": "#phase.cwl/source_id"
                }
            ],
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "from find_cal_global_phaseoffset_losoto import main\nmain(losotoname=\"$(inputs.losoto.path)\",\n     store_basename=\"cwl\",\n     refstationID=$(inputs.refstation_id),\n     sourceID=$(inputs.source_id)\n)\n"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Frequencies",
                    "outputBinding": {
                        "glob": "freqs_for_phase_array.npy"
                    },
                    "id": "#phase.cwl/freqs_for_phase_array"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Phase solutions",
                    "outputBinding": {
                        "glob": "cwl_phase_array.npy"
                    },
                    "id": "#phase.cwl/phase_array"
                },
                {
                    "type": "File",
                    "format": "#phase.cwl/image/png",
                    "outputBinding": {
                        "glob": "phase_xx_yy_offset.png"
                    },
                    "id": "#phase.cwl/phase_xx_yy_offset"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "label": "Station names",
                    "outputBinding": {
                        "glob": "cwl_station_names.npy"
                    },
                    "id": "#phase.cwl/station_names"
                }
            ],
            "id": "#phase.cwl",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": {
                "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
            }
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "losoto"
            ],
            "label": "Plot raw calibration results",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "requirements": [
                {
                    "listing": [
                        {
                            "entryname": "losoto.parset",
                            "entry": "flags                        =  [hdf5file]\nLoSoTo.Steps                 =  [plot]\nLoSoTo.Solset                =  [sol000]\nLoSoTo.Soltab                =  [sol000/phase000]\nLoSoTo.SolType               =  [phase]\nLoSoTo.ant                   =  []\nLoSoTo.pol                   =  [XX,YY]\nLoSoTo.dir                   =  [pointing]\nLoSoTo.Steps.plot.Operation  =  PLOT\nLoSoTo.Steps.plot.PlotType   =  2D\nLoSoTo.Steps.plot.Axes       =  [time,freq]\nLoSoTo.Steps.plot.TableAxis  =  [ant]\nLoSoTo.Steps.plot.ColorAxis  =  [pol]\nLoSoTo.Steps.plot.Reference  =  $(inputs.reference_station) \nLoSoTo.Steps.plot.PlotFlag   =  False\nLoSoTo.Steps.plot.Prefix     =  cwl_\n"
                        },
                        {
                            "entry": "$(inputs.h5parm)",
                            "writable": true
                        }
                    ],
                    "class": "InitialWorkDirRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "format": "http://revoltek.github.io/losoto/cookbook.pdf",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#plot_cal_phases.cwl/h5parm"
                },
                {
                    "type": "string",
                    "id": "#plot_cal_phases.cwl/reference_station"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "losoto.parset",
                    "position": 2
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "format": "#plot_cal_phases.cwl/image/png",
                    "outputBinding": {
                        "glob": "cwl_polXX_dirpointing.png"
                    },
                    "id": "#plot_cal_phases.cwl/polXX_dirpointing"
                },
                {
                    "type": "File",
                    "format": "#plot_cal_phases.cwl/image/png",
                    "outputBinding": {
                        "glob": "cwl_polYY_dirpointing.png"
                    },
                    "id": "#plot_cal_phases.cwl/polYY_dirpointing"
                }
            ],
            "id": "#plot_cal_phases.cwl",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": {
                "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
            }
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python"
            ],
            "label": "Plot clock, TEC, amplitude",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "id": "#plots.cwl/amplitude_array"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "id": "#plots.cwl/dclock_1st_sm"
                },
                {
                    "type": "File",
                    "format": "https://docs.scipy.org/doc/numpy-dev/neps/npy-format.html",
                    "id": "#plots.cwl/dtec_1st_sm"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "format": "#plots.cwl/image/png",
                    "outputBinding": {
                        "glob": "amp_allsols.png"
                    },
                    "id": "#plots.cwl/amp_allsols"
                },
                {
                    "type": "File",
                    "format": "#plots.cwl/image/png",
                    "outputBinding": {
                        "glob": "dclock_allsols.png"
                    },
                    "id": "#plots.cwl/dclock_allsols"
                },
                {
                    "type": "File",
                    "format": "#plots.cwl/image/png",
                    "outputBinding": {
                        "glob": "dtec_allsols.png"
                    },
                    "id": "#plots.cwl/dtec_allsols"
                }
            ],
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "import matplotlib as mpl\nmpl.use(\"Agg\")\nimport numpy as np\nimport pylab\n\namparray   = np.load(\"$(inputs.amplitude_array.path)\")\nclockarray = np.load(\"$(inputs.dclock_1st_sm.path)\")\ndtecarray  = np.load(\"$(inputs.dtec_1st_sm.path)\")\nnumants = len(dtecarray[0,:])\n\nfor i in range(0,numants):\n    pylab.plot(dtecarray[:,i])\npylab.xlabel(\"Time\")\npylab.ylabel(\"dTEC [$10^{16}$ m$^{-2}$]\")\npylab.savefig(\"dtec_allsols.png\")\npylab.close()\npylab.cla()\n\nfor i in range(0,numants):\n    pylab.plot(1e9*clockarray[:,i])\npylab.xlabel(\"Time\")\npylab.ylabel(\"dClock [ns]\")\npylab.savefig(\"dclock_allsols.png\")\npylab.close()\npylab.cla()\n\n\nfor i in range(0,numants):\n  pylab.plot(np.median(amparray[i,:,:,0], axis=0))\n  pylab.plot(np.median(amparray[i,:,:,1], axis=0))\npylab.xlabel(\"Subband number\")\npylab.ylabel(\"Amplitude\")\npylab.ylim(0,2.*np.median(amparray))\npylab.savefig(\"amp_allsols.png\")\npylab.close()\npylab.cla()\n"
                }
            ],
            "id": "#plots.cwl",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": {
                "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
            }
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python"
            ],
            "label": "Find calibrator skymodel",
            "hints": [
                {
                    "dockerPull": "kernsuite/prefactor",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "/usr/share/prefactor/skymodels/",
                    "id": "#sky_cal.cwl/DirSkymodelCal"
                },
                {
                    "type": "string",
                    "default": ".skymodel",
                    "id": "#sky_cal.cwl/extensionSky"
                },
                {
                    "type": "Directory",
                    "id": "#sky_cal.cwl/ms"
                }
            ],
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "from find_skymodel_cal import main\nfrom shutil import copyfile\nfrom os import path\nDirSkymodelCal=\"$(inputs.DirSkymodelCal)\"\nSkymodelCal = main(ms_input=\"$(inputs.ms.path)\",\n     DirSkymodelCal=DirSkymodelCal,\n     extensionSky=\"$(inputs.extensionSky)\",\n)[\"SkymodelCal\"]\nprint(\"SkymodelCal: {}\".format(SkymodelCal))\ncopyfile(path.join(DirSkymodelCal, SkymodelCal), \"selected.skymodel\")\n"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "selected.skymodel"
                    },
                    "id": "#sky_cal.cwl/skymodel"
                }
            ],
            "id": "#sky_cal.cwl",
            "http://schema.org/license": "https://mit-license.org/",
            "http://schema.org/author": {
                "http://schema.org/person.url": "http://orcid.org/0000-0002-6136-3724"
            }
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "https://schema.org/version/latest/schema.rdf"
    ],
    "$namespaces": {
        "s": "http://schema.org/",
        "iana": "https://www.iana.org/assignments/media-types/"
    }
}
